import 'dart:mirrors';

import 'runtime.dart';

bool asBool(dynamic value) {
  if (value is Undefined) return false;
  if (value is bool) return value;
  if (value is num) return value != 0.0;
  if (value is String) return value.isNotEmpty;
  if (value is Iterable) return value.isNotEmpty;
  if (value is Map) return value.isNotEmpty;
  return value != null;
}

String escape(dynamic value) {
  String text = value.toString();
  StringBuffer buffer = StringBuffer();
  for (int ch in text.codeUnits) {
    switch (ch) {
      case 38:
        buffer.write('&amp;');
        break;
      case 34:
        buffer.write('&#34;');
        break;
      case 39:
        buffer.write('&#39;');
        break;
      case 60:
        buffer.write('&lt;');
        break;
      case 62:
        buffer.write('&gt;');
        break;
      case 47:
        buffer.write('&#47;');
        break;
      default:
        buffer.writeCharCode(ch);
    }
  }
  return buffer.toString();
}

dynamic getAttr(String field, dynamic value) =>
    reflect(value).getField(Symbol(field)).reflectee;

bool isNull(dynamic value) => value == null;

List<int> range(int n) => List<int>.generate(n, (int i) => i);

String rprint(dynamic value) => '$value'.replaceAll(RegExp(r'\r\n|\n'), r'\n');
