import 'package:jinja/src/utils.dart' as utils;
import "package:test/test.dart";

// From
// https://github.com/pallets/markupsafe/blob/master/tests/test_escape.py

void main() {
  group('Escape', () {
    test('Empty', () {
      expect(utils.escape(''), equals(''));
    });

    test('Ascii', () {
      expect(utils.escape('abcd&><\'"efgh'),
          equals('abcd&amp;&gt;&lt;&#39;&#34;efgh'));
      expect(utils.escape('&><\'"efgh'), equals('&amp;&gt;&lt;&#39;&#34;efgh'));
      expect(utils.escape('abcd&><\'"'), equals('abcd&amp;&gt;&lt;&#39;&#34;'));
    });

    test('2 byte', () {
      expect(utils.escape('こんにちは&><\'"こんばんは'),
          equals('こんにちは&amp;&gt;&lt;&#39;&#34;こんばんは'));
      expect(
          utils.escape('&><\'"こんばんは'), equals('&amp;&gt;&lt;&#39;&#34;こんばんは'));
      expect(
          utils.escape('こんにちは&><\'"'), equals('こんにちは&amp;&gt;&lt;&#39;&#34;'));
    });

    test('4 byte', () {
      expect(utils.escape('\\U0001F363\\U0001F362&><\'"\\U0001F37A xyz'),
          equals(r'\U0001F363\U0001F362&amp;&gt;&lt;&#39;&#34;\U0001F37A xyz'));
      expect(utils.escape('&><\'"\\U0001F37A xyz'),
          equals(r'&amp;&gt;&lt;&#39;&#34;\U0001F37A xyz'));
      expect(utils.escape('\\U0001F363\\U0001F362&><\'"'),
          equals(r'\U0001F363\U0001F362&amp;&gt;&lt;&#39;&#34;'));
    });
  });
}
